// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/components/entity/EntityAttackBase.hpp"

namespace Dawn {
  class EntityShootingAttack : public EntityAttackBase {
    protected:

    public:
      EntityShootingAttack(SceneItem* item);

      void onStart() override;
      void onDispose() override;

      float_t getAttackRampUpDuration() override;
      float_t getAttackActiveDuration() override;
      float_t getAttackRampDownDuration() override;
      float_t getAttackCooldownDuration() override;
      bool_t isInterruptable() override;
      bool_t canAttack() override;
  };
}